.. _imaging_visibility_data:

Imaging visibility data sets
****************************

Simulated visibilities can be saved to a CASA Measurement Set, so any imager
capable of working with Measurement Sets can be used to image them.

For convenience, OSKAR includes an imager which can be used if all that is
required is a dirty (or residual) image, and it also provides the option to
make images directly from data in numpy arrays. This can often be faster than
writing visibilities out to a Measurement Set and loading them back again in
order to make an image using another program.

An ``oskar.Imager`` instance can be created in Python using a settings tree
for the ``oskar_imager`` application. For example:

.. code-block:: python

    params = {
        'image/fov_deg': 5.0,
        'image/size': 6144,
        'image/algorithm': 'W-projection',  # default is FFT (2D only)
        # The following two options are recommended for large images
        # (particularly when using W-projection),
        # as long as you have enough GPU RAM to hold the complex visibility
        # grid as well as the convolution kernels.
        'image/fft/use_gpu': True,
        'image/fft/grid_on_gpu': True,
        'image/input_vis_data': 'example.vis',  # or 'example.ms'
        'image/root_path': 'example_image'  # Optional: see below
    }
    settings = oskar.SettingsTree('oskar_imager')
    settings.from_dict(params)
    imager = oskar.Imager(settings=settings)

This will generate an image using the visibility data in the file
``example.vis`` (or ``example.ms`` if a Measurement Set is specified instead),
and will write a FITS image in Stokes I called ``example_image_I.fits``.

The image will be centred on the phase centre used in the observation by
default, but it can be re-centred on a different direction by adding the
parameters:

.. code-block:: python

    params = {
        ...  (other parameters here)
        'image/direction': 'RA, Dec.',
        'image/direction/ra_deg': 12.34,  # Insert the required coordinates.
        'image/direction/dec_deg': 56.78
    }

The full list of settings parameters is shown in the OSKAR GUI for the
``oskar_imager`` application, and also in the
`settings documentation <https://developer.skatelescope.org/projects/sim-tools>`_.

After setting it up, call ``oskar.Imager.run()`` to make the image.
If required, the image(s) can be returned directly to Python as a numpy array
instead of (or as well as) writing a FITS file. Use ``return_images=1`` as an
argument to ``oskar.Imager.run()`` and assign the return value to a variable.
This will be a dictionary of arrays holding the image(s), which can be
accessed using the 'images' dictionary key as follows:

.. code-block:: python

    output = imager.run(return_images=1)
    image = output['images'][0]  # Stokes I image.


Making dirty or residual images automatically
---------------------------------------------

Many simulation runs need to make either dirty images, or images of residual
visibilities. The residuals are generated by subtracting a reference
(or model) visibility data set first.

For convenience, the ``ResidualImageSimulator`` class, described below,
can be used to make either dirty or residual images at the same time as
running a simulation. It combines the functionality of ``oskar.Interferometer``
and ``oskar.Imager``, so that residual visibilities can be generated as needed
and processed on-the-fly as the simulation progresses, without needing to
write out visibilities and load them back again to make each image.
If generating residuals, only the reference visibilities need to be saved,
and multiple subsequent runs can use the same reference data set.

This simulator is configured in the same way as ``oskar.Interferometer``,
and can optionally be passed an instance of an imager, and a filename
containing the reference visibility data.
Use it in place of ``oskar.Interferometer`` if you need to make an
image of a simulated data set.

Similar to ``oskar.Imager``, any images created using this simulator will be
returned directly as numpy arrays from the ``run()`` method:

.. code-block:: python

    output = sim.run()
    image = output['images'][0]  # Stokes I image.

See the notes and example in the class documentation (included below)
for usage instructions.


.. autoclass:: scripts.ResidualImageSimulator
   :members:
   :special-members: __init__
   :exclude-members: set_coords_only
